<div align="center"><img src="https://github.com/emmettgb/Lathe.jl/blob/Unstable/lathelogo.png" />
  <h1>0.1.3 "ButterBall"</h1>
</div>
<div align="left">
  <p> Lathe.jl is an all-in-one package for predictive modeling in Julia. It comes packaged with a Stats Library, Preprocessing Tools, Distributions, Machine-Learning Models, and Model Validation. Lathe features easy object-oriented programming methodologies using Julia's dispatch.</p>
        </div>


<details class="details-overlay">
  <summary class="btn"><h2>Add Lathe</h2></summary>
<div>

**(press ] in the Julia REPL to go to Pkg REPL)**
 #### LTS (Long-term support, reccommended):
 ```julia
 (v1.3) pkg> add Lathe#Butterball
 ```
 #### Latest (Get the latest stable developments):
 ```julia
 (v1.3) pkg> add Lathe
 ```
 #### Unstable (Get the latest undocumented and unstable developments):
 ```julia
 (v1.3) pkg> add Lathe#Unstable
 ```
 
</div>
</details>


<details class="details-overlay">
  <summary class="btn"><h2>What's great about Lathe?</h2></summary>
<div>

#### Easy To Use
Lathe brings an entirely different methodology to the Julia language. Types are created to adhere to the object-oriented programming paradigm, and syntax is akin to that of Pythonic machine-learning packages, like SkLearn.
#### Fully Featured
Lathe includes many of the tools commonly used by machine-learning engineers and scientists out of the box, rather than relying on more dependencies to do so.
#### Deployable
Lathe models can be easily serialized and deployed onto production servers using **Genie.jl**, or a similar high-performance web-server. Lathe also has support for pipelines, meaning most pre-processing operations can be automated and performed with one easy call.
#### Fast
Lathe uses a faster methodology than most other Julia packages for machine-learning. Furthermore, the package also takes advantage of the natural ability of the language to be fast. As a result, Lathe is also faster than most similar packages for other high-level statistical programming languages.
#### Julian
Lathe is written in 100-percent pure Julia. As a result, the package often takes advantage of very Julian methods of dealing with problems, such as dispatch, macros, and syntactical expressions.

</div>
</details>

<details class="details-overlay">
  <summary class="btn"><h2>What's Inside?</h2></summary>
<div>

### Stats
- Distributions
- Statistical tests
- Bayesian tests
- Model validation
- Sampling
- General Statistics

### Preprocess
- Scalers
- Encoders
- Splitters
### Models
- Pipelines
- Powerlog
- Logistic Regression
- Kmeans Clustering
- Random Forest Classifier
- Decision Tree Classifier
- Pipelines
- Linear Regression
- Linear Least square

</div>
</details>




<details class="details-overlay">
  <summary class="btn"><h2>Documentation</h2></summary>
<div>
  
 # [Documentation on JuliaHub](https://juliahub.com/docs/Lathe/6rMNJ/0.1.2/)
</div>
</details>

